/***************************************************************/
/*                                                             */
/*                      SAMPLE EHLLAPI PROGRAM                 */
/*                                                             */
/*    Author:  DXD                                             */
/*    Date Written:  10/1996                                   */
/*                                                             */
/***************************************************************/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "hllsmp.h"
#include "hapi_c32.h"                /* Get EHLLAPI include file  */

/*************************************************************/
/* Globals                                                   */
/*************************************************************/

#define systemid "system"
#define userid   "userid"
#define password "password"

#define PSID "a"
#define PS_POS return_code
#define DRV_NUM return_code
#define CLEAR "@C"
#define ENTER "@E"


// forward declares
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK About(HWND, UINT, WPARAM, LPARAM);
BOOL SimpleTest();
void call_hllapi();
void send_keys();

/* Globals */

ULONG i;                       /* general counter */

int    PS_POS;                 /* for PS search */
int    search_rc;

int		hll_function;               /* call parameters */
char		data_string[30];
int		data_length;
int		return_code;

int   expected_return_code;    /* check call result */

char sf_string[47] =
            {"autoexec.bat a:auto bat a (ascii crlf!"};

char q_buffer[36];             /* for query system */
char blank_screen[] =          /* blank screen     */
	{
       "\n"
	};


//**************** WINMAIN *******************************
int CALLBACK WinMain(HINSTANCE hInstance,
							HINSTANCE hPrevInstance,
							LPSTR		 lpCmdLine,
							int		 nCmdShow)

{
	static char szAppName[] = "cHllSmp";
	HWND			hwnd;
	MSG			msg;
	WNDCLASSEX	wndclass;

	wndclass.cbSize			= sizeof(wndclass);
	wndclass.style				= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc		= WndProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon				= LoadIcon (hInstance, "GENERIC");
	wndclass.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	= szAppName;
	wndclass.lpszClassName	= szAppName;
	wndclass.hIconSm			= LoadIcon(NULL, IDI_APPLICATION);

	RegisterClassEx (&wndclass);

	hwnd = CreateWindow(szAppName, "CHllApi Test", 
								WS_OVERLAPPEDWINDOW,
								CW_USEDEFAULT,				// init x pos
								CW_USEDEFAULT,				// init y pos
								CW_USEDEFAULT,				// x size
								CW_USEDEFAULT,				// y size
								NULL,							// parent hwnd
								NULL,							// wnd menu hdn
								hInstance,
								NULL);

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow (hwnd);

	while (GetMessage (&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

return msg.wParam;
}  // end winmain

//******** WNDPROC ***************************************************************
long CALLBACK WndProc (HWND hwnd,
											UINT message,
											UINT wParam,
											LONG lParam)
{
   static HINSTANCE  hInstance; 
   

	switch (message)
   {
		case WM_CREATE:
            hInstance = ((LPCREATESTRUCT) lParam)->hInstance ; 
      return 0 ;
		case WM_COMMAND:
			switch (LOWORD (wParam))
         {
				case IDM_ABOUT:
					DialogBox (hInstance, "AboutBox", hwnd, (DLGPROC) About) ;
            return 0 ;

            case IDM_SIMPLETEST:
					if (SimpleTest())
						MessageBox(hwnd, "SimpleTest worked", "", MB_OK);
					else
						MessageBox(hwnd, "SimpleTest failed", "", MB_OK);
           return 0 ; //IDM_ISLOADED

        } //switch wparam
      break ;  //case WM_COMMAND
		
      case WM_DESTROY :      
			PostQuitMessage (0) ;
      return 0 ;  //case WM_DESTROY
	}                     
    // Process all other messages and return
    return DefWindowProc (hwnd, message, wParam, lParam) ;
}

BOOL SimpleTest()
{
/*************************************************************/
/*  Reset EHLLAPI.                                           */
/*************************************************************/
      hll_function = HA_RESET_SYSTEM;
      expected_return_code = 0;
      call_hllapi();

/*************************************************************/
/*  Establish connection to the host presentation space.     */
/*************************************************************/
      hll_function = HA_CONNECT_PS;
      strcpy (data_string, PSID);
      expected_return_code = 0;
      call_hllapi();

/*************************************************************/
/*  Send the system and user ids to the host.                */
/*************************************************************/
      strcpy (data_string, systemid);
      //strcat (data_string, " ");
      //strcat (data_string, userid);
      //strcat (data_string, ENTER);
      data_length = strlen(data_string);
      send_keys();

/*************************************************************/
/*  Stop host notification and reset 'pause'.                */
/*************************************************************/
      //hll_function = HA_STOP_HOST_NOTIFY;
      //strcpy (data_string, PSID);
      //expected_return_code = 0;
      //call_hllapi();

      //hll_function = HA_SET_SESSION_PARMS;
      //strcpy (data_string, "fpause");
      //data_length = strlen(data_string);
      //expected_return_code = 0;
      //call_hllapi();



/*************************************************************/
/*  Prepare for file transfer by disconnecting from the      */
/*    host presentation space.                               */
/*************************************************************/
      hll_function = HA_DISCONNECT_PS;
      expected_return_code = 0;
      call_hllapi();


	MessageBox(NULL, "wait", "", MB_OK); 

return TRUE;
}

//*************************************************************
void send_keys()
/*************************************************************/
/*  Common sendkey routine.                                  */
/*************************************************************/
{
      hll_function = HA_SENDKEY;
      expected_return_code = 0;
      call_hllapi();
}

void call_hllapi()
/*************************************************************/
/*  Call the hllapi and verify the return code.              */
/*************************************************************/
{
      hllapi (&hll_function, data_string, &data_length, &return_code);

      if (return_code == 9 && hll_function != HA_CONVERT_POS_ROW_COL)
      {
       hll_function = HA_QUERY_SYSTEM;
       hllapi (&hll_function, q_buffer, &data_length, &return_code);
       printf (blank_screen);
       printf ("%s\n",q_buffer);
       exit(9);
      }

   if ((return_code != expected_return_code) &&
       (expected_return_code != -1))
      {
       printf (blank_screen);             /* Clear the screen */
       printf ("hll_function               %d\n", hll_function);
       printf ("Unexpected return code %d\n", return_code);
       printf ("Expected return code   %d\n", expected_return_code);
       printf ("Data string            %s\n", data_string);
      }
}

//*************************************************************************
BOOL CALLBACK About (HWND	hDlg,
									 UINT		iMsg,
									 WPARAM	wParam,
	                         LPARAM	lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
		return TRUE ;

      case WM_COMMAND:
			switch (LOWORD (wParam))
         {
				case IDOK:
				case IDCANCEL:
					EndDialog (hDlg, 0) ;
				return TRUE ;
         }
		break ;
   }
   return FALSE ;
}

